Name:           usdtweak
Version:        2025.04.04
Release:        %autorelease
Summary:        USD Standalone Editor

License:        Apache
URL:            https://github.com/cpichard/usdtweak
Source0:        %{url}/archive/13416dedf146e8dcaf7baa90fd2e519a81f39e68.tar.gz

BuildRequires:  cmake >= 3.14
BuildRequires:  gcc-c++
BuildRequires:  chrpath
BuildRequires:  desktop-file-utils

Requires:       opensubdiv
Requires:       usd
BuildRequires:  usd-devel

BuildRequires:  libglvnd-devel
BuildRequires:  python3-devel
BuildRequires:  yaml-cpp-devel
BuildRequires:  imath-devel
BuildRequires:  glfw-devel
BuildRequires:  wayland-protocols-devel
BuildRequires:  libX11-devel
BuildRequires:  libXext-devel
BuildRequires:  libwayland-cursor
BuildRequires:  libwayland-egl
BuildRequires:  libwayland-server
BuildRequires:  libxkbcommon-x11

# Needed by USD
%if 0%{?fedora} > 40
BuildRequires:  pkgconfig(tbb)
%else
BuildRequires:  pkgconfig(tbb) = 2020.3
%endif
BuildRequires:  cmake(Alembic)
BuildRequires:  hdf5-devel
BuildRequires:  draco-devel
BuildRequires:  openshadinglanguage
BuildRequires:  pkgconfig(oslexec)
BuildRequires:  cmake(OpenImageIO)
BuildRequires:  opensubdiv-devel
BuildRequires:  openvdb-devel
BuildRequires:  pkgconfig(ptex)
BuildRequires:  cmake(OpenColorIO)
BuildRequires:  embree-devel
BuildRequires:  double-conversion-devel
BuildRequires:  pkgconfig(liblz4)
BuildRequires:  pkgconfig(libavif)


%description
USD Standalone Editor.


%prep
%autosetup -p1 -n %{name}-13416dedf146e8dcaf7baa90fd2e519a81f39e68

# Change config file to .config folder
sed -i 's/\/\./\/.config\//g' \
        src/resources/ResourcesLoader.cpp
sed -i 's|glfw3 [0-9.]*|glfw3|g' \
        CMakeLists.txt
# imgui.ini on .config dir instead of relative to workdir
sed -i 's|imgui.ini|~/.config/usdtweak.ini|g' \
        src/3rdparty/imgui/imgui.cpp
sed -i '8a\#include <algorithm> // For std::sort and std::replace' \
        src/widgets/FileBrowser.cpp

# +F42 fix
sed -i 's/ImGui::TextWrapped(\(.*\));/ImGui::TextWrapped("%s", \1);/' \
        src/widgets/ValidationWindow.cpp



%build
%cmake \
-DBUILD_SHARED_LIBS=OFF \
-Dglfw3_DIR=%{_libdir}/cmake/glfw3
%cmake_build

# Build .desktop files
cat > %{name}.desktop <<EOF
[Desktop Entry]
Name=usdtweak
Comment=USD Standalone Editor
Exec=%{name} 
Icon=applications-graphics
Terminal=false
Type=Application
StartupNotify=false
Categories=Graphics;3DGraphics;
EOF


%install
install -Dm755 redhat-linux-build/usdtweak %{buildroot}%{_bindir}/usdtweak
chrpath --delete %{buildroot}%{_bindir}/usdtweak

install -d %{buildroot}%{_datadir}/applications
touch %{name}.desktop
desktop-file-install --dir=%{buildroot}%{_datadir}/applications \
    %{name}.desktop


%files
%license LICENSE
%doc README.md
%{_bindir}/usdtweak
%{_datadir}/applications/%{name}.desktop

%changelog
%autochangelog
